<div class="container">
  <h2>Editor Review</h2>
  <div *ngIf="editorReview$ | async as editorReview">
    <div class="row">
      <div class="col-9"><h3>Publication: {{editorReview.publication['artefact'].object.name}}</h3></div>
      <div class="col-3"><h3>Status:{{getStatusKey(status)}}</h3></div>
    </div>
    <div class="row">
      <div *ngIf="author" clas="col-9"><h3>from: {{getUserString(author)}} </h3></div>
    </div>
    <div class="mb-3">
      <label for="formControlUser" class="form-label">Author</label>
      <input [ngModel]="getUserString(author)" type="string" readonly=true class="form-control" id="formControlUser">
    </div>
    <div class="mb-3">
      <label for="formControlArtefactSnapshot" class="form-label">Artefact to review</label>
      <a [href]="editorReview.artefact_snapshot" target="_blank" class="form-control"
         id="formControlArtefactSnapshot">{{editorReview.publication['artefact'].object.name}}</a>
    </div>

    <div class="mb-3">
      <label for="formControlDate" class="form-label">Document date</label>
      <input ngModel="{{editorReview.publication['modified'] | date:'long'}}" type="datetime" readonly=true
             class="form-control" id="formControlDate">
    </div>
    <div class="mb-3">
      <label for="formControlReviewDate" class="form-label">Request for review date</label>
      <input ngModel="{{editorReview.created | date:'long'}}" type="datetime" readonly=true
             class="form-control" id="formControlReviewDate">
    </div>

    <div class="mb-3">
      <label for="formControlID" class="form-label">Review id</label>
      <input [ngModel]="editorReview.id" type="number" readonly=true class="form-control" id="formControlID"
             placeholder="#">
    </div>

    <div [ngSwitch]="status">
      <ng-container *ngSwitchCase="Status.SENT">
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, accept, 'Accept to review')">Accept</button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, reject, 'Reject the review')">Reject</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.REVIEW_ACCEPTED">
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModalSendForReview, sendForReview, 'Send for review')">
          Send for review
        </button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModalSendReports,requestMinorRevision, 'Request minor revision')">Minor
          update
        </button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModalSendReports,requestMajorRevision, 'Request major revision')">
          Correction
        </button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModalSendReports, reject, 'Reject the publication')">Reject</button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, approve, 'Approve the publication and ask for authorization')">Approve publication</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.PUBLICATION_APPROVED">
        <button type="button" disabled class="btn btn-primary me-3 mb-3">Publish (waiting for authorization)</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.AUTHORIZED">
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, publish, 'Publish on MiCorr')">Publish</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.REJECTED">
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal,accept, 'Accept to review')">Reopen</button>
      </ng-container>
      <ng-container *ngSwitchDefault>
        <i>no action at that stage</i>
        <br>
        <b>But DEBUG ACTION</b>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal,accept)">Reopen</button>
      </ng-container>

      <ng-template #messageModal let-modal>
        <div class="modal-header">
          <h4 class="modal-title" id="message-modal-title">{{modalTitle}}</h4>
          <button type="button" class="btn-close" aria-label="Close" (click)="modal.dismiss('Cross click')"></button>
        </div>
        <div class="modal-body">
          <app-message-form [recipient]="author" (value)="onMessage($event,modal)"></app-message-form>
        </div>
      </ng-template>
      <ng-template #messageModalSendForReview let-modal>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-send-for-review">{{modalTitle}}</h4>
          <button type="button" class="btn-close" aria-label="Close" (click)="modal.dismiss('Cross click')"></button>
        </div>
        <div class="modal-body">
          <app-message-form [selectRecipient]="true" (value)="onMessage($event,modal)"></app-message-form>
        </div>
      </ng-template>
      <ng-template #messageModalSendReports let-modal>
        <div class="modal-header">
          <h4 class="modal-title" id="modal-send-reports">{{modalTitle}}</h4>
          <button type="button" class="btn-close" aria-label="Close" (click)="modal.dismiss('Cross click')"></button>
        </div>
        <div class="modal-body">
          <app-message-form [attachReports]="true" [recipient]="author" [selectRecipient]="false" [reviews]="peerReviews"
                            (value)="onMessage($event,modal)"></app-message-form>
        </div>
      </ng-template>
    </div>
    <app-reviewers [editor_review]="editorReview" (reviews)="onPeerReviewsChange($event)"></app-reviewers>
    <ngb-accordion #acc="ngbAccordion" activeIds="ngb-panel-0">
      <ngb-panel title="Review logs">
        <ng-template ngbPanelContent>
          <app-review-log [object]="reviewLog" *ngFor="let reviewLog of editorReview.review_logs">
          </app-review-log>
        </ng-template>
      </ngb-panel>
    </ngb-accordion>
  </div>
</div>
